Index: squid3/src/ipc.cc
===================================================================
RCS file: /cvsroot/squid-sf//squid3/src/ipc.cc,v
retrieving revision 1.8.2.21
retrieving revision 1.8.2.22
diff -u -r1.8.2.21 -r1.8.2.22
--- squid3/src/ipc.cc	14 May 2006 17:11:06 -0000	1.8.2.21
+++ squid3/src/ipc.cc	3 Sep 2006 16:51:26 -0000	1.8.2.22
@@ -1436,210 +288,79 @@
             select(0, NULL, NULL, NULL, &sl);
         }
 
-        result->result (IPCResult (true, result->mySpawn->getPid(), result->prfd, result->pwfd));
-        return result;
-#endif
-
+        return pid;
     }
-#ifdef _SQUID_MSWIN_
-}
-
-unsigned int
-ipc_params::threadLoop() {
-    int t1, t2, t3;
-
-    struct thread_params thread_params;
-    int tempFD = -1;
-    char *str;
-    int tmp_s;
-
-    struct sockaddr_in CS_ipc, PS_ipc;
-
-    strcpy(buf1, prog);
-    niceprog = strtok(buf1, w_space);
-
-    if ((str = strrchr(niceprog, '/')))
-        niceprog = ++str;
-
-    if ((str = strrchr(niceprog, '\\')))
-        niceprog = ++str;
-
-    niceprog = xstrdup(niceprog);
-
-    assert (myIPC);
 
-    IPC *result = myIPC;
-
-    /* ForkChild is called directly from non windows routines */
-    IPC::ForkChild (myIPC);
-
-#endif
-
-    result->childFDConnect();
-
-    if (!result->childFDConnected())  {
-#ifdef _SQUID_MSWIN_
-        freeResources();
-        return 1;
-#else
-
-        result->cleanUp();
-        _exit (1);
-#endif
-
-    }
+    /* child */
+    no_suid();			/* give up extra priviliges */
 
-    tempFD = result->childFD.rfd;
+    /* close shared socket with parent */
+    close(prfd);
 
-    /* XXX: candidate for extract method */
-    {
-        int sendresult = result->childWrite(hello_string, strlen(hello_string) + 1);
+    if (pwfd != prfd)
+        close(pwfd);
 
-        if (sendresult < 0)
-        {
-            debug(50, 0) ("ipcCreate: CHILD: hello write test failed\n");
-#ifdef _SQUID_MSWIN_
+    pwfd = prfd = -1;
 
-            freeResources();
-            return 1;
-#else
+    if (type == IPC_TCP_SOCKET) {
+        debug(54, 3) ("ipcCreate: calling accept on FD %d\n", crfd);
 
-            result->cleanUp();
+        if ((fd = accept(crfd, NULL, NULL)) < 0) {
+            debug(50, 0) ("ipcCreate: FD %d accept: %s\n", crfd, xstrerror());
             _exit(1);
-#endif
-
         }
-    }
-    PutEnvironment();
-#ifndef _SQUID_MSWIN_
-
-    result->doExec();
-    return 0;
-#else
-
-    memset(buf1, '\0', sizeof(buf1));
-    int recvresult = recv(myIPC->childFD.rfd, (void *) buf1, 8191, 0);
-
-    if (recvresult < 0) {
-        debug(50, 0) ("ipcCreate: CHILD: OK read test failed\n");
-        debug(50, 0) ("--> read: %s\n", xstrerror());
-        freeResources();
-        return 1;
-    } else if (strcmp(buf1, ok_string)) {
-        debug(54, 0) ("ipcCreate: CHILD: OK read test failed\n");
-        debug(54, 0) ("--> read returned %d\n", recvresult);
-        debug(54, 0) ("--> got '%s'\n", rfc1738_escape(hello_buf));
-        freeResources();
-        return 1;
-    }
-
-    /* create FDs for child */
-
-    if (_pipe(p2c, 1024, _O_BINARY | _O_NOINHERIT) < 0) {
-        debug(50, 0) ("ipcCreate: CHILD: pipe: %s\n", xstrerror());
-        ipcSend(myIPC->childFD.wfd, err_string, strlen(err_string));
-        freeResources();
-        return 1;
-    }
 
-    if (_pipe(c2p, 1024, _O_BINARY | _O_NOINHERIT) < 0) {
-        debug(50, 0) ("ipcCreate: CHILD: pipe: %s\n", xstrerror());
-        ipcSend(myIPC->childFD.wfd, err_string, strlen(err_string));
-        freeResources();
-        return 1;
+        debug(54, 3) ("ipcCreate: CHILD accepted new FD %d\n", fd);
+        close(crfd);
+        cwfd = crfd = fd;
+    } else if (type == IPC_UDP_SOCKET) {
+        if (comm_connect_addr(crfd, &PaS) == COMM_ERROR)
+            return ipcCloseAllFD(prfd, pwfd, crfd, cwfd);
     }
 
-    /* assign file descriptors to child process */
     if (type == IPC_UDP_SOCKET) {
-        snprintf(buf1, 8192, "%s(%ld) <-> ipc CHILD socket", niceprog, -1L);
-        crfd_ipc = cwfd_ipc = comm_open(SOCK_DGRAM, IPPROTO_UDP, local_addr, 0, 0, buf1);
-
-        if (crfd_ipc < 0) {
-            debug(54,
-                  0) ("ipcCreate: CHILD: Failed to create child FD for %s.\n",
-                      niceprog);
-            ipcSend(myIPC->childFD.wfd, err_string, strlen(err_string));
-            freeResources();
-            return 1;
-        }
-
-        snprintf(buf1, 8192, "%s(%ld) <-> ipc PARENT socket", niceprog, -1L);
-        prfd_ipc = pwfd_ipc = comm_open(SOCK_DGRAM, IPPROTO_UDP, local_addr, 0, 0, buf1);
-
-        if (pwfd_ipc < 0) {
-            debug(54,
-                  0) ("ipcCreate: CHILD: Failed to create server FD for %s.\n",
-                      niceprog);
-            ipcSend(myIPC->childFD.wfd, err_string, strlen(err_string));
-            freeResources();
-            return 1;
-        }
-
-        tmp_s = sizeof(PS_ipc);
-        memset(&PS_ipc, '\0', tmp_s);
-
-        if (getsockname(pwfd_ipc, (struct sockaddr *) &PS_ipc, &tmp_s) < 0) {
-            debug(50, 0) ("ipcCreate: getsockname: %s\n", xstrerror());
-            ipcSend(myIPC->childFD.wfd, err_string, strlen(err_string));
-            freeResources();
-            return 1;
-        }
-
-        debug(54, 3) ("ipcCreate: FD %d sockaddr %s:%d\n",
-                      pwfd_ipc, inet_ntoa(PS_ipc.sin_addr), ntohs(PS_ipc.sin_port));
-        tmp_s = sizeof(CS_ipc);
-        memset(&CS_ipc, '\0', tmp_s);
-
-        if (getsockname(crfd_ipc, (struct sockaddr *) &CS_ipc, &tmp_s) < 0) {
-            debug(50, 0) ("ipcCreate: getsockname: %s\n", xstrerror());
-            ipcSend(myIPC->childFD.wfd, err_string, strlen(err_string));
-            freeResources();
-            return 1;
-        }
-
-        debug(54, 3) ("ipcCreate: FD %d sockaddr %s:%d\n",
-                      crfd_ipc, inet_ntoa(CS_ipc.sin_addr), ntohs(CS_ipc.sin_port));
+        x = comm_udp_send(cwfd, hello_string, strlen(hello_string) + 1, 0);
 
-        if (comm_connect_addr(pwfd_ipc, &CS_ipc) == COMM_ERROR) {
-            ipcSend(myIPC->childFD.wfd, err_string, strlen(err_string));
-            freeResources();
-            return 1;
+        if (x < 0) {
+            debug(50, 0) ("sendto FD %d: %s\n", cwfd, xstrerror());
+            debug(50, 0) ("ipcCreate: CHILD: hello write test failed\n");
+            _exit(1);
         }
-
-        tempFD = myIPC->childFD.rfd;
-
-        if (comm_connect_addr(crfd_ipc, &PS_ipc) == COMM_ERROR) {
-            ipcSend(myIPC->childFD.wfd, err_string, strlen(err_string));
-            freeResources();
-            return 1;
+    } else {
+        if (write(cwfd, hello_string, strlen(hello_string) + 1) < 0) {
+            debug(50, 0) ("write FD %d: %s\n", cwfd, xstrerror());
+            debug(50, 0) ("ipcCreate: CHILD: hello write test failed\n");
+            _exit(1);
         }
-    }		/* IPC_UDP_SOCKET */
-
-    assert (tempFD == myIPC->childFD.rfd);
-
-    t1 = dup(0);
-
-    t2 = dup(1);
+    }
 
-    t3 = dup(2);
+    PutEnvironment();
+    /*
+     * This double-dup stuff avoids problems when one of 
+     *  crfd, cwfd, or debug_log are in the rage 0-2.
+     */
 
-    dup2(c2p[0], 0);
+    do {
+        /* First make sure 0-2 is occupied by something. Gets cleaned up later */
+        x = dup(crfd);
+        assert(x > -1);
+    } while (x < 3 && x > -1);
 
-    dup2(p2c[1], 1);
+    close(x);
 
-    dup2(fileno(debug_log), 2);
+    t1 = dup(crfd);
 
-    close(c2p[0]);
+    t2 = dup(cwfd);
 
-    close(p2c[1]);
+    t3 = dup(fileno(debug_log));
 
-    commUnsetNonBlocking(tempFD);
+    assert(t1 > 2 && t2 > 2 && t3 > 2);
 
-    SpawnResult spawnResult = ipc_spawn (prog, args);
+    close(crfd);
 
-    pid = spawnResult.pid;
+    close(cwfd);
 
-    hProcess = spawnResult.hProcess;
+    close(fileno(debug_log));
 
     dup2(t1, 0);
 
@@ -1653,315 +374,22 @@
 
     close(t3);
 
-    if (pid == -1) {
-        errno = spawnResult.error;
-        debug(50, 0) ("ipcCreate: CHILD: %s: %s\n", prog, xstrerror());
-        ipcSend(myIPC->childFD.wfd, err_string, strlen(err_string));
-        freeResources();
-        return 1;
-    }
-
-    /* Ok, the child has started */
-    if (type == IPC_UDP_SOCKET) {
-        WSAPROTOCOL_INFO wpi;
-
-        memset(&wpi, 0, sizeof(wpi));
-
-        if (SOCKET_ERROR == WSADuplicateSocket(crfd_ipc, pid, &wpi)) {
-            debug(50, 0) ("ipcCreate: CHILD: WSADuplicateSocket: %s\n",
-                          xstrerror());
-            ipcSend(myIPC->childFD.wfd, err_string, strlen(err_string));
-            freeResources();
-            return 1;
-        }
-
-        int writeresult = write(c2p[1], (const char *) &wpi, sizeof(wpi));
-
-        if (writeresult < 0 || static_cast <size_t>(writeresult) < sizeof(wpi)) {
-            debug(50, 0)
-            ("ipcCreate: CHILD: write FD %d: %s\n", c2p[1],
-             xstrerror());
-            debug(54, 0) ("ipcCreate: CHILD: %s: socket exchange failed\n",
-                          niceprog);
-            ipcSend(myIPC->childFD.wfd, err_string, strlen(err_string));
-            freeResources();
-            return 1;
-        }
-
-        int readresult = read(p2c[0], buf1, 8192);
-
-        if (readresult < 0) {
-            debug(50, 0)
-            ("ipcCreate: CHILD: read FD %d: %s\n", p2c[0],
-             xstrerror());
-            debug(54, 0) ("ipcCreate: CHILD: %s: socket exchange failed\n",
-                          niceprog);
-            ipcSend(myIPC->childFD.wfd, err_string, strlen(err_string));
-            freeResources();
-            return 1;
-        } else if (strncmp(buf1, ok_string, strlen(ok_string))) {
-            debug(54, 0)
-            ("ipcCreate: CHILD: %s: socket exchange failed\n",
-             niceprog);
-            debug(54, 0) ("--> read returned %d\n", readresult);
-            buf1[readresult] = '\0';
-            debug(54, 0) ("--> got '%s'\n", rfc1738_escape(buf1));
-            ipcSend(myIPC->childFD.wfd, err_string, strlen(err_string));
-            freeResources();
-            return 1;
-        }
-
-        int write2result = write(c2p[1], (const char *) &PS_ipc, sizeof(PS_ipc));
-
-        if (write2result < 0 || static_cast<size_t>(write2result) < sizeof(PS_ipc)) {
-            debug(50, 0)
-            ("ipcCreate: CHILD: write FD %d: %s\n", c2p[1],
-             xstrerror());
-            debug(54, 0) ("ipcCreate: CHILD: %s: socket exchange failed\n",
-                          niceprog);
-            ipcSend(myIPC->childFD.wfd, err_string, strlen(err_string));
-            freeResources();
-            return 1;
-        }
-
-        int read2result = read(p2c[0], buf1, 8192);
-
-        if (read2result < 0) {
-            debug(50, 0)
-            ("ipcCreate: CHILD: read FD %d: %s\n", p2c[0],
-             xstrerror());
-            debug(54, 0) ("ipcCreate: CHILD: %s: socket exchange failed\n",
-                          niceprog);
-            ipcSend(myIPC->childFD.wfd, err_string, strlen(err_string));
-            freeResources();
-            return 1;
-        } else if (strncmp(buf1, ok_string, strlen(ok_string))) {
-            debug(54, 0)
-            ("ipcCreate: CHILD: %s: socket exchange failed\n",
-             niceprog);
-            debug(54, 0) ("--> read returned %d\n", read2result);
-            buf1[read2result] = '\0';
-            debug(54, 0) ("--> got '%s'\n", rfc1738_escape(buf1));
-            ipcSend(myIPC->childFD.wfd, err_string, strlen(err_string));
-            freeResources();
-            return 1;
-        }
-
-        /* We should error check this send */
-        send(pwfd_ipc, (const void *) ok_string, strlen(ok_string), 0);
-        int recvrv = recv(prfd_ipc, (void *) (buf1 + 200), 8191 - 200, 0);
-        assert((size_t) recvrv == strlen(ok_string)
-               && !strncmp(ok_string, buf1 + 200, strlen(ok_string)));
-    }	/* IPC_UDP_SOCKET */
-
-    snprintf(buf1, 8191, "%s(%ld) CHILD socket", niceprog, (long int)pid);
-
-    fd_note(tempFD, buf1);
-
-    if (prfd_ipc != -1) {
-        snprintf(buf1, 8191, "%s(%ld) <-> ipc CHILD socket", niceprog, (long int)pid);
-        fd_note(crfd_ipc, buf1);
-        snprintf(buf1, 8191, "%s(%ld) <-> ipc PARENT socket", niceprog, (long int)pid);
-        fd_note(prfd_ipc, buf1);
-    }				/* else {                      // IPC_TCP_SOCKET
-
-    * commSetNoLinger(fd);
-    * }
-    */
-    thread_params.prog = niceprog;
-
-    thread_params.send_fd = myIPC->childFD.wfd;
-
-    thread_params.pid = pid;
-
-    if ((thread_params.type = type) == IPC_TCP_SOCKET)
-        thread_params.rfd = p2c[0];
-    else
-        thread_params.rfd = prfd_ipc;
-
-    thread =
-        (HANDLE) _beginthreadex(NULL, 0, ipc_thread_2, &thread_params, 0, NULL);
-
-    if (!thread) {
-        debug(50, 0) ("ipcCreate: CHILD: _beginthreadex: %s\n", xstrerror());
-        ipcSend(myIPC->childFD.wfd, err_string, strlen(err_string));
-        freeResources();
-        return 1;
-    }
-
-    snprintf(buf1, 8191, "%ld\n", (long int)pid);
-
-    if (-1 == ipcSend(myIPC->childFD.wfd, buf1, strlen(buf1))) {
-        freeResources();
-        return 1;
-    }
-
-    debug(54, 2) ("ipc(%s,%ld): started successfully\n", niceprog, (long int)pid);
-    parentToChildLoop();
-
-    normalExit();
-    freeResources();
-    return 0;
-}
-
-void
-ipc_params::normalExit() {
-    debug(54, 2) ("ipc(%s,%d): normal exit\n", niceprog, pid);
-}
-
-void
-ipc_params::freeResources() {
-    if (c2p[1] != -1)
-        close(c2p[1]);
-
-    if (fd_table[myIPC->childFD.rfd].flags.open)
-        myIPC->childFD.close();
-
-    if (prfd_ipc != -1) {
-        send(crfd_ipc, (const void *) shutdown_string, strlen(shutdown_string), 0);
-        shutdown(crfd_ipc, SD_BOTH);
-        shutdown(prfd_ipc, SD_BOTH);
-    }
-
-    ipcCloseAllFD(prfd_ipc, pwfd_ipc);
-    myIPC->childFD.close();
-
-    if (hProcess && WAIT_OBJECT_0 !=
-            WaitForSingleObject(hProcess, type == IPC_UDP_SOCKET ? 12000 : 5000)) {
-
-        getCurrentTime();
-        debug(54, 0) ("ipc(%s,%d): WARNING: %s didn't exit in %d seconds.\n",
-                      niceprog, pid, niceprog, type == IPC_UDP_SOCKET ? 12 : 5);
-    }
-
-    if (thread && WAIT_OBJECT_0 != WaitForSingleObject(thread, 3000)) {
-        getCurrentTime();
-        debug(54, 0)
-        ("ipc(%s,%d): WARNING: ipc_thread_2 didn't exit in 3 seconds.\n",
-         niceprog, pid);
-    }
-
-    getCurrentTime();
-    safe_free(niceprog);
-#if HAVE_PUTENV
-
-    safe_free(env_str);
-#endif
-
-    if (thread)
-        CloseHandle(thread);
-
-    if (hProcess)
-        CloseHandle(hProcess);
-
-    if (p2c[0] != -1)
-        close(p2c[0]);
-
-#endif
-}
-
-#ifdef _SQUID_MSWIN_
-void
-ipc_params::parentToChildLoop() {
-    /* cycle */
-
-    for (;;) {
-        int recvrv = recv(myIPC->childFD.rfd, (void *) buf1, 8192, 0);
-
-        if (recvrv <= 0) {
-            debug(54, 3) ("ipc(%s,%d): %d bytes received from parent. Exiting...\n",
-                          niceprog, pid, recvrv);
-            return;
-        }
-
-        buf1[recvrv] = '\0';
-
-        if (type == IPC_UDP_SOCKET && !strcmp(buf1, shutdown_string)) {
-            debug(54, 3)
-            ("ipc(%s,%d): request for shutdown received from parent. Exiting...\n",
-             niceprog, pid);
-            //            TerminateProcess(hProcess, 0);
-            return;
-        }
-
-        debug(54, 5) ("ipc(%s,%d): received from parent: %s\n", niceprog, pid,
-                      rfc1738_escape_unescaped(buf1));
-        int writerv;
-
-        if (type == IPC_TCP_SOCKET)
-            writerv = write(c2p[1], buf1, recvrv);
-        else
-            writerv = send(pwfd_ipc, (const void *) buf1, recvrv, 0);
+    /* Make sure all other filedescriptors are closed */
+    for (x = 3; x < SQUID_MAXFD; x++)
+        close(x);
 
-        if (writerv <= 0) {
-            debug(54, 3) ("ipc(%s,%d): %d bytes written to %s. Exiting...\n",
-                          niceprog, pid, writerv, niceprog);
-            return;
-        }
+    if (opt_no_daemon) {
+        squid_signal(SIGINT, SIG_IGN, SA_RESETHAND);
+        squid_signal(SIGHUP, SIG_IGN, SA_RESETHAND);
     }
-}
-
-#endif
-
-void
-IPCInstance::childToParentLoop() {
-    char buf2[8192];
-
-    for (;;) {
-        int x;
-
-        if (type == IPC_TCP_SOCKET)
-            x = read(prfd, buf2, 8192);
-        else
-            x = recv(prfd, (void *) buf2, 8192, 0);
 
-        if ((x <= 0 && type == IPC_TCP_SOCKET) ||
-                (x < 0 && type == IPC_UDP_SOCKET)) {
-            debug(54, 3) ("ipc(%s,%d): %d bytes read from %s. Exiting...\n",
-                          prog, pid, x, prog);
-            break;
-        }
-
-        buf2[x] = '\0';
-
-        if (type == IPC_UDP_SOCKET && !strcmp(buf2, ShutdownMessage)) {
-            debug(54, 3) ("ipc(%s,%d): request for shutdown received. Exiting...\n",
-                          prog, pid);
-            break;
-        }
-
-        if (x >= 2) {
-            if ((buf2[x-1] == '\n') && (buf2[x-2] == '\r')) {
-                buf2[x-2] = '\n';
-                buf2[x-1] = '\0';
-                x--;
-            }
-        }
-
-        debug(54, 5) ("ipc(%s,%d): received from child : %s\n", prog, pid,
-                      rfc1738_escape_unescaped(buf2));
-        x = send(send_fd, (const void *) buf2, x, 0);
-
-        if ((x <= 0 && type == IPC_TCP_SOCKET) ||
-                (x < 0 && type == IPC_UDP_SOCKET)) {
-            debug(54, 3) ("ipc(%s,%d): %d bytes sent to parent. Exiting...\n",
-                          prog, pid, x);
-            break;
-        }
-    }
-}
+    execvp(prog, (char *const *) args);
 
-#ifdef _SQUID_MSWIN_
-static unsigned int __stdcall
-ipc_thread_2(void *voidParam) {
+    debug_log = fdopen(2, "a+");
 
-    struct thread_params *params = static_cast<struct thread_params *>(voidParam);
-    IPCInstance *newInstance = new IPCInstance(params->type, params->pid, params->prog, params->rfd, params->send_fd);
+    debug(50, 0) ("ipcCreate: %s: %s\n", prog, xstrerror());
 
-    newInstance->childToParentLoop();
+    _exit(1);
 
-    delete newInstance;
     return 0;
 }
-
-#endif
